//
// Project Name: Planets Version of Bouncing Ball
//
// Author: Matthew Weathers
// Modified by: YOUR NAME HERE
//
// Date  : 28-Oct-2005

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "graphics2.h"

using namespace std;

#define ESC 0x1b

void main() 
{
	srand((unsigned int)time(NULL));  // Seed the random number generator
	int GraphDriver=0,GraphMode=0;
	initgraph( &GraphDriver, &GraphMode, "", 800, 600 ); // Start Window
	char tempstring[80]="unused";

	//Variable Declarations

	bool KeepGoing=true;
	bool GravityOn=false;
	char KeyPressed;

	double ballX, ballY;
	double prevX, prevY;
	double XVel, YVel;

	int mouseX, mouseY;

	double sunX = 400.0;
	double sunY = 300.0;
	//double dist, gravX, gravY;

	//Draw the sun
	setcolor(YELLOW);
	setfillstyle(SOLID_FILL,YELLOW);
	fillellipse((int) sunX, (int) sunY, 10, 10);

	// Initial Position
	ballX = 540.0;
	ballY = 150.0;

	// Initial Velocity
	XVel = 5.8;
	YVel = 6.1;

	//Main Loop
	while ( KeepGoing ) {
		delay( 25 );

		// -------------------- Move and Control the Ball -------------------------

		// Remember previous position
		prevX = ballX;
		prevY = ballY;

		// Move the ball (Add Velocity to Position)
		ballX += XVel;
		ballY += YVel;

		// ---- Put Gravity Here




		// Erase old Ball
		setcolor(BLACK);
		circle( (int) prevX, (int) prevY, 20);

		// Draw New ball
		setcolor(WHITE);
		circle( (int) ballX, (int) ballY, 20);

		// Bounch off left/right walls
		if ( ballX > 770.0  || ballX < 30.0) {
			XVel *= -1.0;
		}
		// Bounch off top/bottom walls
		if ( ballY > 570.0  || ballY < 30.0) {
			YVel *= -1.0;
		}


		// -------------- Check to see if a key has been pressed ---------------------
		if (kbhit()) {
			KeyPressed = getch();

			// KEY: Q or ESC pressed
			if (KeyPressed == 'q' || KeyPressed=='Q' || KeyPressed==ESC) {  // q - quit
				KeepGoing = false;
			}//end if (Q)

			//Toggle Gravity with G key
			if (KeyPressed == 'g' || KeyPressed=='G') {  // q - quit
				if (GravityOn){
					GravityOn=false;
				} else {
					GravityOn=true;
				}
			}//end if (G)

		}//end if kbhit()

		// ------------------ Check to see Mouse was clicked ------------------------

		if (mousedown()) {
			mouseX = mouseclickx();
			mouseY = mouseclicky();

			// ------- Respond to mouse click ---------

			// Erase old Ball
			setcolor(BLACK);
			circle( (int) ballX, (int) ballY, 20);

			//Reset ball to where the user clicked
			ballX = mouseX;
			ballY = mouseY;

		}//end if mousedown()
	} // end while kbhit

} //end of main()
